import "./src/assort/slim.css"
import "./src/assort/app.css"

import Vue from 'vue';

import FApp from "./src/App.vue";
import FSection from "./src/components/wrapper/BSection";
import FContainer from "./src/components/wrapper/BContainer";

import { Requestor } from "./src/models/Requestor";

import { TitleWithSub } from "./src/models/elements/TitleWithSub";
import { Direction } from "./src/models/elements/Direction";
import { Iteration } from "./src/models/elements/Iteration";
import { Profile } from "./src/models/elements/Profile";
import { Request } from "./src/models/Request";
import { Section } from "./src/models/elements/Section";
import { Article } from "./src/models/elements/Article";
import { Action } from "./src/models/elements/Action";
import { Dialog } from "./src/models/elements/Dialog";
import { Status } from "./src/models/elements/Status";
import { Field } from "./src/models/Field";
import { Title } from "./src/models/elements/Title";
import { Tiles } from "./src/models/elements/Tiles";
import { List } from "./src/models/elements/List";
import { Text } from "./src/models/elements/Text";

import { store } from "./src/plugins/helper";
import { inside } from "./src/plugins/helper";

const Components = {
    FApp,
    FSection,
    FContainer
};

Object.keys(Components).forEach(name => {
    Vue.component(name, Components[name]);
});

export {
    TitleWithSub,
    Requestor,
    Action,
    Article,
    Dialog,
    Direction,
    Field,
    Iteration,
    List,
    Profile,
    Request,
    Section,
    Status,
    Text,
    Title,
    Tiles,
    store,
    inside
};