export class Verify {
    constructor(field = null) {
        this._field = field;
        this.keys(['bind']);
    }
    selector() {
        let success = true;
        if (this.header()) {
            this._field._config.header.forEach((h, index) => {
                if (index) {
                    let has = h.type === 'Selector';
                    if (!has) {
                        success = false;
                        console.error(`The config HEADER for a LISTING should only have type Selector`);
                    }
                }
            });
        }
        return success;
    }
    header() {
        let success = true;
        if (!this._field._config.header) {
            console.error(`No config HEADER for the type: ${this._field._type} bound by: ${this._field._config.bind}`);
            return false;
        }
        if (!Array.isArray(this._field._config.header)) {
            console.error(`The config HEADER is not an ARRAY for the type: ${this._field._type} bound by: ${this._field._config.bind}`);
            return false;
        }
        let keys = ['text', 'value', 'type', 'show'];
        this._field._config.header.forEach((h, index) => {
            keys.forEach(key => {
                let has = Object.keys(h).includes(key);
                if (!has) {
                    success = false;
                    console.error(`The config HEADER at INDEX: ${index} is missing key: ${key} for the type: ${this._field._type} bound by: ${this._field._config.bind}`);
                }
            });
        });
        return success;
    }
    items() {
        if (!this._field._config.items) {
            console.error(`No config ITEMS for the type: ${this._field._type} bound by: ${this._field._config.bind}`);
            return false;
        }
        else {
            if (typeof this._field._config.items !== 'function') {
                console.error(`The config ITEMS is not a function for the type: ${this._field._type} bound by: ${this._field._config.bind}`);
                return false;
            }
        }
        return true;
    }
    keys(keys = []) {
        let success = true;
        keys.forEach(k => {
            if (!this._field._config[k]) {
                success = false;
                console.error(`No config ${k} for the type: ${this._field._type} bound by: ${this._field._config.bind}`);
            }
        });
        return success;
    }
}
//# sourceMappingURL=Verify.js.map