export class Verify
{
    public _field: any;

    constructor(field: any = null) {
        this._field = field;
        this.keys(['bind'])
    }

    public selector()
    {
        let success = true;

        if (this.header())
        {
            this._field._config.header.forEach((h: any, index: number) => {
                if (index) {
                    let has = h.type === 'Selector'
                    if (!has) {
                        success = false;
                        console.error(`The config HEADER for a LISTING should only have type Selector`);
                    }
                }
            });
        }

        return success;
    }

    public header()
    {
        let success = true;

        if (!this._field._config.header) {
            console.error(`No config HEADER for the type: ${this._field._type} bound by: ${this._field._config.bind}`);
            return false;
        }

        if (!Array.isArray(this._field._config.header)) {
            console.error(`The config HEADER is not an ARRAY for the type: ${this._field._type} bound by: ${this._field._config.bind}`);
            return false;
        }

        let keys = ['text', 'value', 'type', 'show'];
        this._field._config.header.forEach((h: any, index: number) => {
            keys.forEach(key => {
                let has = Object.keys(h).includes(key);
                if (!has) {
                    success = false;
                    console.error(`The config HEADER at INDEX: ${index} is missing key: ${key} for the type: ${this._field._type} bound by: ${this._field._config.bind}`)
                }
            });
        });

        return success;
    }

    public items()
    {
        if (!this._field._config.items) {
            console.error(`No config ITEMS for the type: ${this._field._type} bound by: ${this._field._config.bind}`)
            return false;
        } else {
            if (typeof this._field._config.items !== 'function') {
                console.error(`The config ITEMS is not a function for the type: ${this._field._type} bound by: ${this._field._config.bind}`);
                return false;
            }
        }

        return true;
    }

    public keys(keys: any[] = [])
    {
        let success = true;

        keys.forEach(k => {
            if (!this._field._config[k]) {
                success = false;
                console.error(`No config ${k} for the type: ${this._field._type} bound by: ${this._field._config.bind}`);
            }
        })

        return success;
    }
}