import { Field } from "./../../models/Field";
import { Verify } from "./../../models/Verify";
import { FieldBase } from "./extend/FieldBase";
export class FieldAutocomplete extends FieldBase {
    constructor(field = null) {
        super(field);
        if (this._field !== null)
            this.verify();
    }
    // Ensure that the config object is correct.
    verify() {
        this._verify = new Verify(this._field);
        this._verify.keys(['required', 'objectValue', 'objectId', 'searchUrl']);
        this._verify.items();
    }
    editorConfig($this, bind) {
        return new Field('', 'config', '', {
            bind: bind,
            bindOverwrite: true,
            default: true,
            required: false,
            formatModel: () => {
                return {
                    config: {
                        searchUrl: $this.c.helper.getModelFromField(`${bind}-config`, 'searchUrl'),
                    },
                };
            }
        });
    }
    editorSection($this, bind) {
        super.editorSection($this, bind);
        this._editor.push(this.editorConfig($this, bind));
        this._editor.push(new Field('Search URL', 'searchUrl', 'Text', {
            bind: `${bind}-config`,
            bindOverwrite: true,
            class: 'pt-4',
            helper: 'Retur-værdien herfra skal være en array med nøglerne: id og value',
            required: false,
        }));
        return this._editor;
    }
}
//# sourceMappingURL=FieldAutocomplete.js.map