import {FieldBase} from "./extend/FieldBase";

export class FieldColorPicker extends FieldBase
{
    constructor(field: any = null)
    {
        super(field);
    }

    public format(value: { shade: string, color: string }, $this: any)
    {
        return value.shade ?? value.color;
    }

    public default()
    {
        this._field._model = { color: null, shade: null };

        if (this._field._config.default)
        {
            let color = this._field._config.defaultFunction ? this._field._config.default().split(' ') : this._field._config.default.split(' ');

            if (color.length === 1) {
                this._field._model = { color: color[0], shade: null };
            } else if (color.length > 1) {
                this._field._model = { color: color[0], shade: `${color[0]} ${color[1]}` };
            }
        }
    }
}