import { FieldBase } from "./extend/FieldBase";
import { FieldListing } from "./../fields/FieldListing";
export class FieldCreator extends FieldBase {
    constructor(field = null) {
        super(field);
        if (this._field !== null)
            this.verify();
    }
    // Ensure that the config object is correct.
    verify() {
        this._verify.keys(['helper']);
        this._verify.items();
    }
    default(data, bind = 'undefined') {
        return data.type;
    }
    format(data, $this) {
        let bind = `${this._bind}-${data.toLowerCase()}`;
        return {
            label: $this.c.helper.getModelFromField(`${bind}-config`, 'label'),
            label_text: $this.c.helper.getModelFromField(`${bind}-config`, 'label_text'),
            required: !!$this.c.helper.getModelFromField(`${bind}-config`, 'required')?.[0],
            class: $this.c.helper.getModelFromField(`${bind}-config`, 'class'),
            items: (new FieldListing).format($this.c.helper.getModelFromField(`${bind}-config`, 'listing'), this) ?? [],
            type: data,
        };
    }
    editorSection($this, bind) {
        return [];
    }
}
//# sourceMappingURL=FieldCreator.js.map