import {FieldBase}      from "./extend/FieldBase";
import {FieldListing}   from "./../fields/FieldListing";

export class FieldCreator extends FieldBase
{
    constructor(field: any = null)
    {
        super(field);
        if (this._field !== null) this.verify();
    }

    // Ensure that the config object is correct.
    public verify()
    {
        this._verify.keys(['helper']);
        this._verify.items();
    }

    public default(data: any, bind: string = 'undefined')
    {
        return data.type;
    }

    public format(data: any, $this: any)
    {
        let bind = `${this._bind}-${data.toLowerCase()}`;
        return {
            label: $this.c.helper.getModelFromField(`${bind}-config`, 'label'),
            label_text: $this.c.helper.getModelFromField(`${bind}-config`, 'label_text'),
            required: !!$this.c.helper.getModelFromField(`${bind}-config`, 'required')?.[0],
            class: $this.c.helper.getModelFromField(`${bind}-config`, 'class'),
            items: (new FieldListing).format($this.c.helper.getModelFromField(`${bind}-config`, 'listing'), this) ?? [],
            type: data,
        }
    }

    public editorSection($this: any, bind: string)
    {
        return [];
    }
}