import {Verify} from "../../Verify";
import {Field} from "../../Field";

export class FieldBase
{
    public _field: any;
    public _bind: string = 'undefined';
    public _verify: any;

    public _editor: any[] = [];
    public _hasItems: boolean = false;
    public _hasMapping: boolean = false;

    constructor(field: any = null)
    {
        this._field     = field;
        this._bind      = field?._config.bind ?? this._bind;

        if (this._field !== null) {
            this._verify = new Verify(this._field);
        }
    }

    public format(r: any, $this: any)
    {
        return r;
    }

    public default(r: any)
    {
        return r;
    }

    public editorSection($this: any, bind: string)
    {
        this._editor.push(new Field('Title', 'label', 'Text', {
            bind: `${bind}-config`,
            bindOverwrite: true,
            helper: 'Angiv en titel til feltet',
            class: 'pt-4',
            default: $this.item._config.default?.label ?? null,
        }))

        this._editor.push(new Field('', 'required', 'Checkbox', {
            bind: `${bind}-config`,
            bindOverwrite: true,
            helper: 'Angiv hvorvidt feltet skal udfyldes',
            class: '',
            required: false,
            default: $this.item._config.default?.required ? [1] : [],
            items: [{ id: 1, value: 'Ja, dette felt skal udfyldes' }],
        }))

        this._editor.push(new Field('Helper', 'label_text', 'TextArea', {
            bind: `${bind}-config`,
            bindOverwrite: true,
            helper: 'Angiv en hjælpe tekst under feltet',
            class: 'pt-4',
            dense: true,
            required: false,
            default: $this.item._config.default?.label_text ?? null,
        }))

        /*
        this._editor.push(new Field('Class', 'class', 'Text', {
            bind: `${bind}-config`,
            bindOverwrite: true,
            helper: 'Angiv design klasser til feltet',
            class: 'pt-4',
            dense: true,
            required: false,
            default: $this.item._config.default?.class ?? null,
        }))
        */

        return this._editor;
    }
}