import { FieldBase } from "./FieldBase";
import { Field } from "../../Field";
import { Title } from "../../elements/Title";
export class FieldItems extends FieldBase {
    constructor(field = null) {
        super(field);
    }
    editorSection($this, bind) {
        super.editorSection($this, bind);
        this._editor.push(new Title('Elementer', { class: 'pt-2', classInner: 'pl-3' }));
        this._editor.push(new Field('Items', 'listing', 'Listing', {
            bind: `${bind}-config`,
            class: 'pt-4',
            required: false,
            default: $this.item._config.default?.items ?? [],
            input: {
                uniqueIdentifier: 'input',
                value: new Field('Værdi', 'value', 'Text', {
                    bind: `${bind}-config`,
                    class: 'mt-1 mb-2 mr-2 ml-2',
                    dense: true,
                    singleLine: true,
                    noErrorMessage: true,
                }),
                order: new Field('Sortering', 'order', 'Text', {
                    bind: `${bind}-config`,
                    class: 'mt-1 mb-2',
                    dense: true,
                    singleLine: true,
                    noErrorMessage: true,
                }),
            },
            header: [
                { text: '', value: '', type: 'Actions', show: true, width: 50, align: 'center' },
                { text: 'Værdi', value: 'value', type: 'Selector', show: true },
                { text: 'Sortering', value: 'order', type: 'Selector', show: true },
            ]
        }));
        return this._editor;
    }
}
//# sourceMappingURL=FieldItems.js.map